package org.sc3d.apt.sss.v3;

/** Represents an auto-extending buffer for integers. */
public class IntBuffer {
  /** Constructs an empty IntBuffer. */
  public IntBuffer() {
    this.buffer = new int[8];
    this.used = 0;
  }
  
  /* New API. */
  
  /** Appends 'n' to this IntBuffer. For convenience, this method returns 'this'. */
  public IntBuffer append(int n) {
    if (this.used>=this.buffer.length) {
      final int[] old = this.buffer;
      this.buffer = new int[old.length*2];
      System.arraycopy(old, 0, this.buffer, 0, this.used);
    }
    this.buffer[this.used++] = n;
    return this;
  }
  
  /** Returns the contens of this IntBuffer in a fresh array. */
  public int[] toArray() {
    final int[] ans = new int[this.used];
    System.arraycopy(this.buffer, 0, ans, 0, this.used);
    return ans;
  }
  
  /* Private. */
  
  private int[] buffer;
  private int used;
}
